/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2011, 2012, 2014
  Free under LGPL
*/

#include "normal.h"
#include "jxswitch.h"
#include "options.h"
#include "fspdir.h"
#include "dirext.h"
#include "dirloop.h"
#include "fsptime.h"
#include "numbtype.h"
#include "write.h"
#include "read.h"
#include "fcu.h"
#include "infor.h"
#include "conspace.h"
#include "stdfun.h"
#include "dlist.h"
#include "../../objcom/comm.h"

static int  arMsg;

static FILE *dirfp, *main_fp;

static const char *osMDir;

#ifdef		FSP_COMMA
const char *expoCmds[6]={
"//	Main file of fsplus exported project, 2005 ~ 2015\n",
"//  RunTime-Lib export one dir's number as text, Format \n//  NumbSet -m=<Mode>  -t=<Type>  -u=<dau>  -l=len1,len2...\n\
//  -l    often use for exported by program,\n//  use carefully(advise no use) by handwrite\n\
//  Type   [C]har, [S]hort, [L]ong, [B]yte, [W]ORD, [D]WORD\n\n",
"//		-- export at %s\n\n",
"\n\nimpcreat %s %s -u=%d -d=%d -n=%d\n\n",
"\nmkdir %s %s -m=%s -u=%d -d=%d -n=%d --cd\n",
"\nexe %s    // OS-file\n"};
const char **dscpts=expoCmds;
#else
static const char **dscpts,
	fmt[2]={'^'};
#endif

static fsp_dir *inpdir;

static const char FSPnam[]="FreeStarPlus\n",
	numbSet[]="\nnumbset %d -m=%s -t=%s %s\n",
	sysNumbSet[]="\nsysnumbset %d -m=%s -t=%s %s\n";
/*
OEM-dir can't export, OEM-num can be export
*/
static const char rwMode[]="rwho";

#define force  pagemore

BOOL readTo(fsp_dir *dir, BYTE *unit, int T, int n, FILE *fp)
{
  char *type, modebuf[8], typebuf[n+2];
  int len, j, udau, numb;
  MAU send[n];
  if(T){
	type=(char *)unit+FCU_TypePos(dir->Format);
	for(j=0; j<n; j++)typebuf[j]=TypeChr[type[j]];
  }
  else memset(typebuf, 'v', n);
  numb=FCU_Numb(dir, unit);
  if((udau=readFCU(dir, unit, send, n))<1)return False;
  char fmtstr[udau*6+20];
  typebuf[udau]=0;
  len=sprintf(fmtstr,"-u=%d -l=", udau);
  for(j=0; j<udau; j++)len+=sprintf(fmtstr+len, "%u,", send[j].len);
  fmtstr[len-1]=0;
  paraExpre(unit[1],modebuf, rwMode);
  fprintf(fp, dir->lib->sys_Id_done ? sysNumbSet : numbSet, numb, modebuf, typebuf, fmtstr);
  for(j=0; j<udau; j++){
	fwrite("{\n",2,1, fp);
	if(send[j].buf/*&&send[j].len>0*/){
		outCvt(send+j, T ? type[j] : (BYTE)_void);
		fwrite(send[j].buf,send[j].len,1, fp);
		free(send[j].buf);
	}
	fwrite("\n}\n", 3,1, fp);
      }
return True;
}

static int NumbExpo(fsp_dir *dir,BYTE *dsb)
{
  int Num_FCUs_Block, unitlen, n, T, i;
  fsp_lib *lib=dir->lib;
  if(lib->sys_Id_done){
	n=1;	Num_FCUs_Block=SYS_ID_BLOCK;
	T=0;	unitlen=FCU_NumPos+sizeof(DAU);
	}
  else {
	n=dir->DAUC;	Num_FCUs_Block=dir->Num_FCUs_Block;
	T=isType(dir->Format);	unitlen=dir->Num_FCU_Len;
	}

  for(i=0; i<Num_FCUs_Block; i++,dsb+=unitlen){
    if(*dsb==1 && ( lib->sys_Id_done || canAccess(dsb[1]/*mode*/ ) /* can read & not hide */) ){
	if(arMsg){
		char  *dirnam=pdPathNam(dir, inpdir, 2),
		*pth=catstr(osMDir, dirnam, '/');
		readAr(dir, dsb, 0 /*releadir*/, force|128, pth);
		free(dirnam);	free(pth);
		}
	else readTo(dir, dsb, T, n, dirfp);
	}
  }
  return 1;
}

static int pdExpo(fsp_dir *pcdir,fsp_dir *dir)
{
  char stylebuf[20];
  int i, len;
  if(arMsg==0&&dirfp&&dirfp!=main_fp)fclose(dirfp);
  len=0; stylebuf[0]=0;
  for(i=0;i<pd_param_cnt/*rtl_chr[i] '#' not suppose now */;i++)
	if(dir->Format&(1<<i))len+=sprintf(stylebuf+len, "-%c ", rtl_chr[i]);
  if(isNormDir(dir)){
    char  *dirnam=pdPathNam(dir, inpdir, 2),
	*pth=catstr(osMDir, dirnam, '/');
    if(access(pth, 0)==0||mkdir(pth, 0755)==0){
        if(arMsg==0){
	char  modebuf[8], *rtlfile=catstr(pth, "runtime.rls", ROOT_CH);
	dirfp=fopen64(rtlfile, "wb");
	free(rtlfile);
	fwrite(dscpts[1],strlen(dscpts[1]),1,dirfp);
/*	dn=strchr(dirnam, '/');
	if(dn)dn++;
	else dn=dirnam;*/
	paraExpre(dir->mode,modebuf, rwMode);
	fprintf(main_fp,dscpts[4], dirnam, stylebuf,
	modebuf, dir->DAUC,dir->Dir_FCUs_Block,dir->Num_FCUs_Block);
	fprintf(main_fp,"  \t//\t%s", fspAscTim(dir->datebuf));
	rtlfile=catstr(dirnam, "runtime.rls", ROOT_CH);
	fprintf(main_fp, dscpts[5], rtlfile);
	free(rtlfile);
	if(pcdir)fwrite("cd *\n", 5, 1, main_fp);
	}
    }
    else fspHB(41,True);
    free(dirnam); free(pth);
  }
  else if(arMsg==0){ // isRoot
	fprintf(main_fp,dscpts[3],dir->lib->fname,stylebuf,
		dir->DAUC,dir->lib->Dir_FCUs_Block,dir->lib->Num_FCUs_Block);
	dirfp=main_fp;
	}
  return 1;
}

void Export(fsp_lib *send,int n,char **pm, int isAr)
{
int msg, brwVal[BrowsModeCnt];
char *pt;
memset(brwVal, 0, sizeof(int)*BrowsModeCnt);
static const char *releaChs[BrowsModeCnt]=	{ "-n", "-d", "-i", "-t", "-F" },
	*_releaChs[BrowsModeCnt]={ "--num", "--dir", "--include", "--total", "--force" };
ProcOpt expOpt={
	BrowsModeCnt-1,
	browsMode, /*  { "-n", "-d", "-i", "-t", "-p" } */
	_browsMode,
	brwVal,	0, NULL
	},
	releaOpt={
	BrowsModeCnt,
	releaChs, _releaChs,
	brwVal,	0, NULL
	};
arglists *lst=procParas(n, pm, isAr ? &releaOpt : &expOpt, NULL);
fsp_dir *dir;
switch(lst->argc){
case 0 : fspHB(60, True);
	showUsage(FSP_export);
	goto _exit_;
case 1 : /* must  do DirOpen(),  as  follow  pd_close()	 */
	pt=NULL; goto _jmp2_;
default : pt=lst->argv[1];
	_jmp2_: dir=DirOpen(send->CurDir, pt);
} 
msg=getBM(brwVal);/* -F set pagemore, ==-p */
if((msg&3)==0)
	msg=isAr ? 7 : 1;
arMsg=isAr;
if(idxdscpt>0x7ffd){
  char *os_dir, *_fnam=lst->argv[0], *fr=NULL;
  inpdir=dir;
  if(_fnam==NULL){
	os_dir=(char *)"."; goto _skp_;
	}
  if(*_fnam=='~' && _fnam[1]=='/'){
	os_dir=catstr(getenv(homestr), _fnam+2, '/');
	fr=os_dir;
	}
  else os_dir=_fnam;

  if(access(os_dir,0)==0||mkdir(os_dir,0755)==0){
_skp_: if(arMsg)goto _jmp1_;
#ifndef  FSP_COMMA
    if(dscpts==NULL){
	char *expdec=GetManu(32);
	int cn=7;
	dscpts=(const char **)setargv(expdec, fmt, &cn);
    }
#endif
    { 	char buf2[2048];
	getcwd(buf2, 2047);
	pt=rstrrchr(os_dir[0]=='.'&&os_dir[1]==0? buf2:os_dir,ROOT_CH, ROOT_CH);
	pt=catstr(os_dir,pt,ROOT_CH);
    }
    _fnam=catstr(pt,RLS,0);	free(pt);
   if((main_fp=fopen64(_fnam,"wb"))!=NULL){
	char buf1[12];
	fwrite(dscpts[0], strlen(dscpts[0]),1,main_fp);
	fspTime(0, (BYTE *)buf1);    
	fprintf(main_fp, dscpts[2], fspAscTim((BYTE *)buf1));
	fprintf(main_fp, FSPnam);
	dirfp=main_fp;
_jmp1_:	osMDir=os_dir/*fullname(os_dir)*/;
	pdExpo((fsp_dir *)NULL,dir);
	if(arMsg==0){
	    if(isRoot(dir)){
		send->sys_Id_done=True;
		fprintf(dirfp, "// ________ NUMB_SYS_ID : ________\n");
		BrowNumbs(dir, NumbExpo);
		fprintf(dirfp, "// _______ NUMB_SYS_ID end _______\n\n");
	    }
	    DirFullBrow(dir,msg,NumbExpo,pdExpo);
	    if(dirfp&&dirfp!=main_fp)fclose(dirfp);
	    fclose(main_fp);
	    msgShow("Export done !");
	}
	else DirFullBrow(dir,msg,NumbExpo,pdExpo);
     }
     if(arMsg==0)free(_fnam);
  }
  else fspHB(41,True);
  if(fr)free(fr);
  pd_close(dir,2);
}
else reportBug();
_exit_: argsFree(lst);
}

