/*
  Designed by LinJiangHua(Xempo) 2004-2006, 2014
  Free under LGPL
*/

#include "stdfun.h"
#include <sys/stat.h>
#include "msgid.h"
#include "normal.h"

int (*msgShow)(const char *txt);
void (*getMsg)(const char *buf);
int (*popMsg)(const char *,const char *, int , void *X);
void (*PrnTxt)(int x, int attrib, const char *buf);

extern int fspHB(int idx,int msg); /* infor.h */

void *fspX;

const char *separChr(const char *pt)
{
const char *ptr=NULL;
while(*pt){
	if(*pt=='\\'||*pt=='/')ptr=pt;
	pt++;
	}
return ptr;
}

int isdone(int val, const int *msg)
{
while(*msg && *msg!=val)msg++;
return *msg;
}

char *fullname(const char *fname)
{
char buf[2048];
if(*fname!='/'){
	getcwd(buf, 2047);
	return catstr(buf,fname,ROOT_CH);
}
return strdup(fname);
}

char *rstrrchr(char *pth,char fnd,char rep)
{
char *pt=strrchr(pth,fnd);
if(pt){
  if(fnd!=rep)*pt=rep;
  return pt+1;
}
return pth;
}

#include "ignorestr.c"

char *strchrs(const char *src,const char *chrs)
{
if(src)while(*src){
	if(strchr(chrs,*src))return (char *)src;
	src++;
	}
return NULL;
}

char *IsExec(const char *fname,const char **pExt, const char *inpPath)
{
char *buff=NULL;
if(fname){
  int len, i;
  const char *fn, *tmp;
  if(*fname=='~' && fname[1]=='/'){
	fn=catstr(getenv(homestr), fname+2, '/');
	tmp=fn;
	}
  else { fn=fname;  tmp=NULL; }
  if(access(fn, F_OK)==0)
	return tmp ? (char *)fn : strdup(fn);

  if(inpPath){
	fn=catstr(inpPath, fn, '/');
	if(access(fn, F_OK)==0){
		if(tmp)free((void *)tmp);
		return (char *)fn;
		}
	}
  if(strchr(fn,'.')==NULL){
	len=strlen(fn);
	buff=(char *)malloc(len+10);
	scopy(buff,fn);
	for(i=0;pExt[i];i++){
	  scopy(buff+len,pExt[i]);
	  if(access(buff, F_OK)==0)goto _rt_;
	}
	free(buff);	buff=NULL;
	}
_rt_:	if(inpPath)free((void *)fn);
	if(tmp)free((void *)tmp);
}
return buff;
}

unsigned int FmtTxt(char *buf,unsigned int len)
{
  register unsigned int i;
  for(i=0;i<len;i++)if(buf[i]=='\r'){
	if(buf[i+1]=='\n'){
		register unsigned int j;
		for(j=i; j<len; j++)buf[j]=buf[j+1];
		len--;
		}
	else buf[i]='\n';
  }
  return len;
}

char *ReadFile(const char *fname,unsigned int *filelen, int txtmsg, void *X, StrList *lst)
{
unsigned int siz=0;
unsigned int len;
int idxerr;
char *buf;
const char *rc;
FILE *fp;
if((fp=pathopen(fname, R_OK, &rc, lst))==NULL){
	idxerr=0; goto skp;
	}
else {/* open ok */
  struct stat64 st1;
  fstat64(fp->_fileno, &st1);
  siz=st1.st_size;
  if(siz<=0)siz=1023998;
  free((void *)rc);
  if(siz>FspLimit){
	idxerr=40;
skp2:	fclose(fp);
skp:	if(X)popMsg(fname,"ReadFile", -2, X);
	else {
		msgShow(fname);
		fspHB(idxerr, 1);
	}
	return siz>FspLimit ? (char *)fname : NULL;
	}
  len=siz;
  if((buf=(char *)malloc(len+2))==NULL){ idxerr=FAIL_MEM_12; goto skp2;  }
  len=fread(buf,1,len,fp);
  fclose(fp);	buf[len]=0;
  if(filelen)*filelen=txtmsg? FmtTxt(buf,len):len;
  return buf;
	}
}

#include "atoi_lst.c"

const char TypeStr[17][6]={"char", "short", "int","long",
	"byte", "word", "uint", "dword",
	"BYTE","WORD","UINT", "DWORD",
	"None", "Separ", "_Void", "Txt", "Sold" };

const char *getints(const char *pt, int *type)
{
static const int chrlen[Int_TypeCount]={4,5, 3,4,
		4,4,4,5,
		4,5,5,5
		};
int j;
const char *ptr, *tmp;
for(j=0;j<Int_TypeCount;j++){/* _Int-type */
   ptr=strstr(pt,TypeStr[j]);
   if(ptr&&*pt=='('){
	tmp=pt+1;
	while(tmp<ptr){
		if(*tmp!=32 && *tmp !=9)return NULL;
		tmp++;
		}
	ptr+=chrlen[j];
	*type=j;
	while(*ptr==32||*ptr==9)ptr++;
	if(*ptr!=')')return NULL;
	else ptr++;
	return ptr;
	}
 }/* _Int-type */
return NULL;
}

int extParaLen(const char *pt)
{
int n, ch;
for(n=0;(ch=pt[n])!='\\'&& (ch|32)!=32 && ch!=9; n++) ;
return n;
}

int GetComm(char *buf, const char *comstr, const _Int *kval, char **extparm)
{
  while(*buf==32||*buf==9)buf++;
  if(*buf==0)return EmptyEnter;
  unsigned int n, k;
  const char *pt;
  static const char memblk[5]={ 13,10,',' , ';' , 0};
  char tmp[80];
  int ch, rt;
  for(n=0; n<79&&(ch=buf[n])!='.' && (ch|32)!=32 && (ch!='\\'||ch!='/')&&ch!=9; n++)tmp[n]=ch;
  if(n==0)return NotCommand;// must do, ../path as param, GetComm(param, "---help,-h/h,-?/?" ,,)
  rt=NotCommand;
  pt=comstr;
 rechk: pt=memstr(pt,0,tmp,n,1);
  if(pt){
	if( memchr(memblk,pt[n], 5) &&
         (pt==comstr||strchr(memblk,pt[-1])) ){
		k=0;
		while(pt>comstr)if(strchr(memblk,*(--pt)))k++;
		rt=kval[k];
	  }
	  else { pt+=n; goto rechk; }
	}
  if(extparm){
		if( ch=='.' ){
		if(extParaLen(buf+n+1))*extparm=buf+n+1;
		}
		else *extparm=NULL;
	}
  return rt;
}

#include "inpfmtch.c"
#include "calc.c"
#include "calcerr.c"
#include "envpath.c"
#include "params.c"
#include "getconf.c"
#include "options.c"
#include "filter.c"
