/*
	Write by LinJuangHua(xempo) 12-2013
	Copyright LinJiangHua 2013-2014
	Free under LGPL
*/

#include <qcursor.h>
#include <qfontdatabase.h>
#include <qlineedit.h>
#include <qtextcodec.h>
#include "fspdir.h"
#include "dirloop.h"
#include "write.h"
#include "script.h"
#include "filesan.h"
#include "xfunc.h"
#include "inputdlg.h"
#include "fspcon.h"
# include "proedit.h"
#include "../rtdata/en/target/filesor.h"
#include "../rtdata/en/target/proedit.h"

#include "highlight.h"
#include "editor.h"
#include "peconf.h"

extern const char slot_find[], slot_find2[];  // searchmodify.h

const char ProEditNam[]="ProEdit 0.8",	baknam[]="peb", rb[]="rb",
	slot_save[]=SLOT(save()),
	slot_popCodecMenu[]=SLOT(popCodecMenu()),
	**_proedit_;

QString pe_findchs;

file_pos	*menuFilesPos, *menuWdgsSiz;
char *menuIsMaxs; //  one : isMax, other : _codec
int mdfCount,	hlpnum;

QPtrList <ProEdit> proEditList;

ProEdit::ProEdit(Filesan *wdg, const char *fnam, int num) :
	QMainWindow(wdg, NULL,WType_TopLevel|WDestructiveClose),
	_Params(__params), fileNam(fnam), edt(NULL), numb(num),
	findResult(false), Modified(false), undo_Avai(false), 
	findMode(-1), _codec(-1), enCodeced(false), baktm(0)
{
proEditList.prepend(this);
setFont(wdg->font());
if(_proedit_==NULL)_proedit_=charsFromFSP(3);
}


void setTextEdit(QTextEdit *edt, char *buf, unsigned int Len, int codec)
{
buf[Len]=0;
edt->setText(_setCodec(codec)->toUnicode(buf));
free(buf);
}

void ProEdit::createCStyleMenu(const char *txt, int n)
{
csid[n]=cstyle->insertItem(QString::fromUtf8(txt), n);
if( __params[1]/*pms_cStyle*/==n )cstyle->setItemChecked(csid[n], true);
}

int ProEdit::exec(int pos, const char *fun)
{
char *buf;
unsigned int Len;
if(pos==PRO_FSP_WRITE){ buf=(char *)fun; Len=strlen(fun); }
else {
	buf=ReadFile(fileNam, &Len, 0, NULL, &pathList);
	if(buf==fileNam){ close(); return -1; }
}
if(buf){
	int  fnd, x, y, isMax,
	*w, *ip;
	bool C;
	if(numb>-1&&(fnd=menulst.find(fileNam))>-1){
		isMax=menuIsMaxs[fnd*2];
		_codec=menuIsMaxs[fnd*2+1];
		w=(int *)(menuWdgsSiz+fnd);
		ip=(int *)(menuFilesPos+fnd);
		resize(w[2], w[3]);
		if(pos>0){
			x=pos;	y=0;
		}
		else {
			x=ip[0];	y=ip[1];
			}
	}
	else {
		fnd=-1;		isMax=0;
		x=pos>0 ? pos : 0;	y=0;
		_codec=pms_defaultCodec;
		resize(screenWidth*4/5, screenHeight*4/5);
	}

	QToolBar *tb=new QToolBar("tool", this, Qt::DockBottom);
	tb->setMovingEnabled(false);
	QToolBar *ftb=new QToolBar("fontbar", this, Qt::DockTop);
	ftb->setMovingEnabled(false);
	edt=new Editor(this);
	setCentralWidget(edt);
	edt->setPaletteBackgroundColor(0xe6e6e6);
	if(numb<0||namefilters(fileNam,"*.c,*.cpp,*.h,*.hpp,*.def,*.cxx,*.cc,*.c++,*.glabe,*.pro,*.prj,*.bas,*.frm,*.pas,*.java,*.class,*.rls",1))
		edt->setWordWrap(QTextEdit::NoWrap);

	QAction *newAct=creatTA(this, ftb, newImg, newChs, SLOT(new()), Key_F2);
	creatTA(this, ftb, dirOpenImg, openPath, slot_openpath, Key_F11);
	ftb->addSeparator();
	creatTA(this, ftb, codecImg, deCodec, slot_popCodecMenu, 0);
	ftb->addSeparator();
	creatTA(this, ftb, genSetImg, confChs, SLOT(conf()), 0);
	if((C=numb>-1&&namefilters(fileNam,"*.c,*.cpp,*.h,*.hpp,*.def,*.cxx,*.cc,*.c++,*.java,*.class,*.rls",1)) ){
		cstyle=new QPopupMenu(this);
		cstyle->setFont(font());
		cstyle->setCheckable(true);
		createCStyleMenu(fervorY, 0);
		createCStyleMenu(WRAMchs, 1);
		menuButton(cstyleImg, cStyleChs, ftb, cstyle, ALT+Key_C);
		connect(cstyle, sigactIdx, this, SLOT(cstyle(int)) );
	}
	creatTA(this, tb, saveAsCodeImg, saveAsCode, SLOT(popSaveAsC()), 0);
	saveAct=creatTA(this, tb, saveImg, curSave, slot_save, CTRL+Key_S);
	saveAllAct=creatTA(this, tb, saveallImg, allSave, SLOT(saveAll()), CTRL+SHIFT+Key_S);
	saveAct->setEnabled(false);
	saveAllAct->setEnabled(mdfCount);
	sbar=new StatusPanel(tb, 1);
	tb->setStretchableWidget(sbar);

	StatusPanel *topbar=new StatusPanel(ftb, 1);
	ftb->setStretchableWidget(topbar);
	cursorPos=new QLabel(tb);

	connect(edt,SIGNAL(cursorPositionChanged(int,int)), this, SLOT(showCursor(int,int)) );
	creatTA(this, tb, searchImg, findChs, slot_find, CTRL+Qt::Key_F);
	creatTA(this, tb, searchNextImg, findNext, slot_find2/*findNext*/, Qt::Key_F3);
	creatTA(this, tb, searchBackImg, findBack, SLOT(findBack()), Qt::Key_F4);
	creatTA(this, ftb, faqImg, helpChs, SLOT(PEHelp()), Key_F1);
	sbar->showMsg(tryRightClick);
	struct stat64 st;
	if(pos>PRO_FSP_WRITE){
		setIcon(*pixmapLoad(proEditImg));
		lstat64(fileNam, &st);
		docIcon=freqIco[ S_ISLNK( st.st_mode) ? ICO_LINKOBJ :
			(access(fileNam, X_OK) ? ICO_NORM : ICO_EXEC_FILE) ];
	}
	else {
		docIcon=freqIco[ICO_FSP_WRI];
		setIcon(*docIcon);
		}

	if(C)new HighLighter( edt, _colors[pms_cStyle], lineStyle[pms_cStyle] );
	QFont fnt;
	if( ReadFont(fnt, proEditFontId) ){
		if(C){
			edt->getHL()->setFnt(fnt);
			edt->getHL()->_init();
			}
		else edt->setFont(fnt);
		}
	else if(C){
		edt->getHL()->setFnt(edt->font());
		edt->getHL()->_init();
		}
	setTitle();
	if(numb>-1){
		selfpath=strdup(fileNam);
		char *pt=strrchr(selfpath,'/');
		pt[ pt==selfpath ? 1 : 0 ]=0;
		stat64(selfpath, &st);
		if(isWritable(uId, gId, &st)==false)newAct->setEnabled(false);
	}
	else selfpath=NULL; // for newText

	stat64(fileNam, &mdfst);
	setTextEdit(edt, buf, Len, _codec);
	if(fnd>-1)edt->setContentsPos(ip[2], ip[3]);
	edt->setCursorPosition(x, y);
	if(pos>0)edt->find(fun,true,false);
	if(isMax)showMaximized();
	else {
		if(fnd>-1)move(w[0],w[1]);
		show();
	}

	connect(edt, SIGNAL(textChanged()), this, SLOT(editChange()) );
	connect(edt, SIGNAL(undoAvailable(bool)), this, SLOT(undoInfo(bool)) );
	return 1;
}
// QApplication::beep();
close();
return 0;
}

char *orghlp;
void ProEdit::getHelp(const char *fun, bool nx, bool blur)
{
fsp_dir *help=pd_open(fspRoot, "Help", DIR_READ);
if(help){
  MAU funs, pos[2];
  char *pt, *dat, *tmp;
  bool same=(orghlp&&strcmp(orghlp, fun)==0);
  int num=nx ? (same ? hlpnum : 0) : 0,
	idx;
  unsigned int L=strlen(fun), lens;
  fsp_dir *fpos=pd_open(help, "pos", DIR_READ);
  while(num<fpos->selfnumbs){
    numbRead(help, num, &funs, 1, true);
    numbRead(fpos, num, pos, 2, true);
    dat=funs.buf;	tmp=dat;
    lens=funs.len;
_rechk_:  pt=memstr(dat, lens, fun, L,3);
    if( pt ){
        if( blur || (pt[-1]==0||pt==tmp) && pt[L]==0   ){
	idx=0;	dat=tmp;
	while(dat!=pt){
		if(*dat++==0)idx++;
		}
	((Filesan *)parentWidget())->doProEdit(pos->buf, false, ((int *)pos[1].buf)[idx], fun);
	if(same==false){
		if(orghlp)free(orghlp);
		orghlp=strdup(fun);
		}
	hlpnum=num+1;
	free(tmp);		freeMAU(pos,2);
	goto _ex_;
	}
        else {
	dat=pt+L;
	if(dat<tmp+funs.len){
		lens=funs.len-(dat-tmp);
		goto _rechk_;
		}
	}
     }
   free(tmp);	freeMAU( pos,2);
   num++;
   }
QApplication::beep();
sbar->showMsg(noHelp, 99);
_ex_: pd_close(help,2);
pd_close(fpos,2);
}
}

void ProEdit::setTitle()
{
if(numb>-1){
	char buf[32];
	if(numb)sprintf(buf, " <%d>", numb+1);
	else *buf=0;
	if(access(fileNam, W_OK))strcat(buf, " (OR)");
	setCaption(tranText(strCodec,fileNam)+buf);
}
else {
	static const char fspWrite[]="Fsplus numbset";
	setCaption(fspWrite);
	fileNam=fspWrite;
	}
}

void ProEdit::notModified(bool fresh)
{
if(Modified){
ProEdit *pe;
mdfCount--; // don't change 2016-3-19
if(fresh){
	saveAct->setEnabled(false);
	Modified=false;
	if(numb>-1)setIcon(*pixmapLoad(proEditImg));
}
if(mdfCount<1)for(int i=0; (pe=proEditList.at(i)); i++)
		if(this!=pe||fresh)pe->saveAllAct->setEnabled(false);
}
}

inline void Filesan::browNumb(FspCon *wdg)
{
if(modul==_FSPLUS)
	BrowNumbs(treeview->getFspDir(), _selFspNum);
setFspCons(wdg);
}

int ProEdit::fspWrite()
{
void *wdg;
fsp_lib *fsp=pCwd->lib;
fsp_dir *tmp=fsp->CurDir;
char *txt=strdup(edt->text().local8Bit());
fsp->CurDir=pCwd;
wdg=fspX;
((Filesan *)parentWidget())->setFspCons((FspCon  *)this);
OverWrite=0;
CommNumb=0;
fspScript(fsp, txt, 0, NULL);
((Filesan *)parentWidget())->browNumb((FspCon *)wdg);
free(txt);
if(tmp!=pCwd){
	pd_close(pCwd, 2);
	fsp->CurDir=tmp;
}
return CommNumb;
}

// fresh : -1 backup, 0 not fresh,  1 fresh, 2 saveAs code
bool ProEdit::save(int fresh, int code)
{
if(Modified||code>-1){
  if(numb>-1){
     char *fnam = fresh<0 ? catstr(fileNam, baknam, '.') : (char *)fileNam;
     FILE *fp=fopen(fnam, "wb");
     if(fresh<0)free(fnam);
     if(fp){
	QCString s(_setCodec(code>-1 ? code : _codec )->fromUnicode(edt->text()));
	fwrite(s, s.length(),1,fp);
	fclose(fp);
	baktm=0;
	if(fresh>-1)stat64(fnam, &mdfst);
     }
     else {
	char *msg=catstr(fileNam, fwriteFail, '/');
	sbar->showMsg(msg, 99, 1, 0x901810);
	free(msg);
	QApplication::beep();
	return false;
	}
  }
  else switch(fspWrite()){
	case 4 : // Esc
		return false;
	case 1 :  // no write
	case 3 : return (code==-2);  /*? true : false;*/ // skipAll
//	default /* 0 */ : ;// if( sw>5 ){// dlgbtn idx, error in numbset ? 
	}
   if(fresh>-1){
	notModified(fresh);
	if(numb>-1)edt->setSavePos();
	}
}
return true;
}

void ProEdit::showCursor(int p, int i)
{
    char bu[56];
    int  ps=edt->paragraphs();
    sprintf(bu, "  %d:%d  %d%c  ", p+1 , i+1, ps<2 ? 0 : 100*p / (ps-1), '%' );
    cursorPos->setText(bu);
}

bool ProEdit::trySave(int fresh)
{
switch(infoWidget(fileNam, NULL, fresh ? saveForEncodec : isSave, this)){
case 1 : notModified(fresh);
	 break;
case 0 : if(save(fresh))
		break;
default :  return false;
}
return true;
}

inline void Filesan::newText(const char *pth)
{
char *fn=createObj(pth, 43/* creatfile */);
if(fn){
	doProEdit(fn, false);
	free(fn);
	}
}

bool ProEdit::event( QEvent *e)
{
int i, t, C, f, T;
switch( T=e->type() ){
case QEvent::WindowActivate : 
	if(numb>-1){
		struct stat64 st;
		pathList.argv[1]=selfpath;
		if(stat64(fileNam, &st)==0 && (st.st_size!=mdfst.st_size ||  st.st_mtime!=mdfst.st_mtime) ){
			mdfst=st;
			switch(infoWidget(fileNam, NULL, beMdfReloadId, this)){
			case 0 : { //  first btn 
				unsigned int Len;
				char *buf=ReadFile(fileNam, &Len, 0, NULL, &pathList);
				setTextEdit(edt, buf, Len, _codec);
				if(edt->getHL())
					((HighLighter *)edt->getHL())->init();
				notModified(true);
				}
				break;
			case 2 :// opens 
				((Filesan *)parentWidget())->doProEdit(fileNam, true);
			}
		}
	}
case QEvent::WindowDeactivate : // first than WindowActivate
	if(proEditList.count()>1 && proEditList.remove(this) )proEditList.prepend(this);
	break;
case QEvent::ShowMaximized : isMax=1;
	break;
case QEvent::ShowNormal :
	isMax=0;
	tms=0;
	tmId=startTimer(12);
	return true;
case QEvent::Timer :
	if(++tms>2){
		if(isActiveWindow())killTimer(tmId);
		else {
			raise();	setActiveWindow();
		}
	}
	return true;
case QEvent::Close : 
     if(edt){
	ProEdit *pe;
	if(Modified){
		if(numb>-1){
			if(trySave(0)==false)goto _ret_;
		}
		else if(save(1, -2)==false){
			_ret_: sysCmdId=-1;
			return false;
			}
	}
	if(numb<0)goto _endclose_;
	QPtrList <ProEdit> tmp(proEditList);
	hide();
	C=proEditList.count();
	for(t=1; t<C; t++)
	  for(i=0; (pe=proEditList.at(i)); i++)
		if(pe->numb==t&&t>numb&&pe->fileNam&&strcmp(pe->fileNam, fileNam)==0){
			pe->numb--;
			pe->setTitle();
			proEditList.remove(pe);
			break;
			}
	proEditList=tmp;
	int  ip[4], var[4];
	C=menulst.count();
	f=menulst.find(fileNam);	i=f;
	if(f>-1&&isMax)memcpy(var, menuWdgsSiz+f, sizeof(file_pos));
	if(i<0 && menulst.limit()==C )i=0;
	if(i>-1)for(t=i; t<C; t++){
		memcpy(menuFilesPos+t,menuFilesPos+t+1, sizeof(file_pos));
		memcpy(menuWdgsSiz+t, menuWdgsSiz+t+1, sizeof(file_pos));
		memcpy(menuIsMaxs+t*2, menuIsMaxs+(t+1)*2, 2);
		}
	edt->getCursorPosition(ip, ip+1);
	ip[2]=edt->contentsX();
	ip[3]=edt->contentsY();
	C=menulst.add(fileNam);
	memcpy(menuFilesPos+C, ip,sizeof(int)*4);
	if(isMax==false){
		var[0]=x(); var[1]=y();
		var[2]=width();
		var[3]=height(); // no frameGeometry().height(), because use resize() when setWdgFrame, look above
		}
	else if(f<0){
		var[0]=20;	var[1]=10;
		var[2]=screenWidth*4/5;	var[3]=screenHeight*4/5;
		}
	memcpy(menuWdgsSiz+C, var, sizeof(int)*4);
	menuIsMaxs[2*C]=isMax;
	menuIsMaxs[2*C+1]=_codec;
	free(selfpath);
    } // edt!=NULL
    if(pms_baktm){
	char *fn=catstr(fileNam, baknam, '.');
	remove(fn);
	free(fn);
	}
    free((void *)fileNam);
_endclose_:   proEditList.remove(this);
}
return QMainWindow::event( e );
}


static QMetaObjectCleanUp cleanUp_ProEdit( ProEditNam, &ProEdit::staticMetaObject );
const QUParameter cursor_param[2]={ {NULL, &static_QUType_int, 0, QUParameter::In},
		{NULL, &static_QUType_int, 0, QUParameter::In}
		};
const QUParameter bool_param={ NULL, &static_QUType_bool,0,QUParameter::In	};

const QUMethod slot_2int={ NULL, 2, cursor_param };
const QUMethod slotBOOL={ NULL, 1, &bool_param };

QMetaObject *ProEdit::metaObj = 0;
QMetaObject *ProEdit::staticMetaObject()
{
 if(metaObj==0){
 static const QMetaData proEdit_slots[]={
	{"save()", &slot_0_0,  QMetaData::Private },
	{"editChange()", &slot_0_0, QMetaData::Private },
	{"showCursor(int,int)", &slot_2int, QMetaData::Private},
	{"find()", &slot_0_0, QMetaData::Private },
	{"find2()", &slot_0_0, QMetaData::Private }, // findNext
	{"findBack()", &slot_0_0, QMetaData::Private },
	{ "saveAll()", &slot_0_0,  QMetaData::Private },
	{ "asDC()", &slot_0_0,QMetaData::Private },
	{ "recent()",&slot_0_0, QMetaData::Private },
	{ "popAct(int)", &slot_int,  QMetaData::Private },
	{ "lnkopen()" ,&slot_0_0, QMetaData::Private },
	{ "menuOpen(int)", &slot_int,  QMetaData::Private },
	{"undoInfo(bool)", &slotBOOL, QMetaData::Private },
	{ "codec(int)" , &slot_int, QMetaData::Private }, // 13
	{ "popSaveAsC()" , &slot_0_0, QMetaData::Private },
	{ "popCodecMenu()", &slot_0_0,QMetaData::Private },
	{ "closeAll()", &slot_0_0,  QMetaData::Private }, // pe
	{ "quitPrg()",&slot_0_0, QMetaData::Private },
	{"PEHelp()", &slot_0_0, QMetaData::Private },
	{ "clearPElst()" , &slot_0_0, QMetaData::Private },
	{"develHelp()", &slot_0_0, QMetaData::Private },
	{"selAs()", &slot_0_0, QMetaData::Private },
	{"popPluzone()" ,&slot_0_0, QMetaData::Private },
	{"cstyle(int)", &slot_int, QMetaData::Private },
	{"conf()", &slot_0_0, QMetaData::Private }, // 24
	{"new()", &slot_0_0, QMetaData::Private },
	{"PZpath()", &slot_0_0, QMetaData::Private },
	{"clippath()", &slot_0_0, QMetaData::Private }
	};
  metaObj = QMetaObject::new_metaobject(ProEditNam, QMainWindow::staticMetaObject(), proEdit_slots, 28,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_ProEdit.setMetaObject( metaObj );
    }
  return metaObj;
}

void ProEdit::setFnt(const QString &fn, const char *sz, bool bold, bool italic, bool underline)
{
	QFont fnt(fn, atoi(sz), bold ? QFont::Bold : QFont::Normal, italic);
	fnt.setUnderline(underline);
	SavFont(fnt, proEditFontId);
	if(edt->getHL()){
		edt->getHL()->setFnt(fnt);
		edt->getHL()->restore();
		edt->getHL()->init();
		}
	else edt->setFont(fnt);
}

bool ProEdit::qt_invoke( int Id, QUObject* quo )
{
ProEdit *pe;
char *buf;
int  p, i, sw= Id - staticMetaObject()->slotOffset();
switch(sw){
case 0 :	save(1);
	break;
case 1 : // proEditChange
   if(enCodeced==false){
	edt->getCursorPosition( &p , &i );
	showCursor(p, i);
	if(edt->todoMsg==false)edt->recorTextPos(p);
	else {
		edt->todoMsg=false;
		if(edt->testMdf(p)||undo_Avai==false&&edt->saveMsg()==false){
			notModified(true);
			goto _update_;
		}
	}
	if(Modified==false){
		Modified=true;
		mdfCount++;
		if(numb>-1)setIcon(*pixmapLoad(proEditMdfImg));
		saveAct->setEnabled(true);
		for(i=0; (pe=proEditList.at(i)); i++)pe->saveAllAct->setEnabled(true);
	}
_update_:	if(edt->update){
		edt->updateContents();
		edt->update=false;
		}
	}
   else enCodeced=false;
	break;
case 12 :	undo_Avai=quo[1].payload.b;
	break;
case 19 : 	menulst.resetMem(NULL);
	break;
case 2 :  	showCursor( p=quo[1].payload.i, quo[2].payload.i );
	edt->setPosRc(p);
	break;
case 5 : // findback
case 4 : // findnext
case 3 :	bool  ok;
static int  dlgRt=(_cs ? chkCase : 0) | (_wd ? chkWord : 0 ) | (_bk ? chkBackward : 0 );
#define	repl	((msg&1)==1)
#define	repall	((msg&2)==2)
	int tag, msg;	
	msg=dlgRt;
	if( sw==3 || findResult==false /*|| findchs.length()<1*/ ){
	InputDlg fnddlg(this, 0, msg|msgFindRepl, searchModifyImg);
	msg=fnddlg.exe(pe_findchs, edt->selectedText(), p_fndcomblst, NULL, p_repcomblst);
	if(msg==-1||(msg&3)==3/*cancelBtn*/)return false;
	dlgRt=msg;
	}
     ok=false;	tag=0;
     _cs=msg&chkCase;
     _wd=msg&chkWord;
     switch(sw){
     case 5 : _bk=true;
	break;
     case 4 : _bk=false;
	break;
     default : _bk=(bool)(msg&chkBackward);
     }
findAgain: // if(_bk && edt->selectedText()==findchs )edt->moveCursor(QTextEdit::MoveBackward, false);
	findResult=edt->find(pe_findchs, _cs, _wd, !_bk);
	edt->getCursorPosition(&p, &i);
	if( findResult==false ){
	     findMode=-1;
	    if(ok==false){
		if( tag || (p==0&&i==0) )infoWidget(pe_findchs.utf8(), NULL, infoNoFound, this);
		else if( infoWidget(pe_findchs.utf8(), NULL, infoGoOnFind, this)==doContinue){
				if(_bk)edt->setCursorPosition( edt->lines()-1, edt->paragraphLength(edt->lines()-1));
				else edt->setCursorPosition(0,0);
				tag=1;
				goto findAgain;
				}
		}
	}
	else {
		findMode=sw;
		tag=0;		showCursor(p, i);
		if( repl && infoWidget(replchs.utf8(), NULL, infoReplace, this )==doContinue||
		 repall && ( ok || infoWidget(replchs.utf8(), NULL, infoAllRepl, this)==doContinue)
		 ){
		edt->styleFeel();
		edt->insert(replchs);
		if(repall){ ok=true; goto findAgain; }
		}
	}
	break;
case 8 : //edt->keysFunc(Key_F5,0);	break;
	if(proEditList.count()<1)break;
case 9 : showTop(proEditList.at(sw!=8 ? quo[1].payload.i : 1));
	break;
case 11 : ((Filesan *)parentWidget())->doProEdit(menulst.lstIndex(quo[1].payload.i), menuClickStat&Qt::ControlButton);
	break;
case 6 : 	for(i=0; (pe=proEditList.at(i)); i++)pe->save(1);
	break;
case 18 : edt->keysFunc(Key_F1,0);
	break;
case 10 : edt->keysFunc(Key_F6, 0);
	break;
case 20 : edt->keysFunc(Key_F8, 0);
	break;
case 21 : edt->keysFunc(Key_S, AltButton); // use selFileTag to select text
	break;
case 22 : edt->keysFunc(Key_F12, 0);
	break;
case 26 : edt->keysFunc(Key_F11, 0);
	break;
case 27 : edt->keysFunc(Key_F7, 0);
	break;
case 24 : if(PEcfgs)showTop(PEcfgs);
	else {
		PEcfgs=new PEConf(this, "PEConf");
		PEcfgs->execu(400, 438, 12);
	}
	break;
case 25 : ((Filesan *)parentWidget())->newText(selfpath);
	break;
case 23 : p=quo[1].payload.i;
	for(i=0; i<cs_modul_cnt; i++)
		cstyle->setItemChecked(csid[i], p/*pms_cStyle*/==i);
	pms_cStyle=p;
	edt->getHL()->setCStyle(_colors[pms_cStyle], lineStyle[pms_cStyle]);
	goto _rehighlight_;
case 13 : if(popVal!=15){
		if(save(1 , quo[1].payload.i))sbar->showMsg(scOK, 99);
	}
	else if(Modified==false || trySave(1) ){
	  unsigned int L;
	  buf=ReadFile(fileNam, &L, 0, this, &pathList);
	  if(buf){
		int x, y;
		enCodeced=true; // disable SLOT(editChange())
		edt->getCursorPosition(&x, &y);
		setTextEdit(edt, buf, L, _codec=quo[1].payload.i);
		edt->setCursorPosition(x, y);
		sbar->showMsg(" Encode againt", 60);
_rehighlight_:	if(edt->getHL())
			edt->getHL()->init();
		}
	}
	break;
case 14 : // popSaveAsC()
case 15 : {
	QPopupMenu pop(this);
	QPopupMenu menu(this);
	popVal=sw;
	popCodecMenu(this, &pop, &menu, sw!=14 ? pms_defaultCodec : -3, _codec );
	pop.exec(QCursor::pos());
	}
	break;
case 7 :	if(pms_defaultCodec!=-1)pms_defaultCodec=-1;
	else pms_defaultCodec=_codec;
	break;
case 17 :
case 16 :  appPost( 64994+sw, this, parentWidget() );	// 65010, 65011
	break;
default : return QMainWindow::qt_invoke(Id, quo);
}
return true;
}

#ifndef QT_NO_PROPERTIES
bool ProEdit::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES
