/*
	Designed & modify by Linjianghua
	Copyright 2004-2005 Linjianghua
	Reserve all right of this file
*/

#include "fspdir.h"
#include "dirext.h"
#include "stdfun.h"
#include "extfunc.h"
#include "_fastblock.cpp"
#include "fastblock.cpp"
#include "browslist.cpp"

extern StrList pathList; // pluzone.h

void scopy(char *d, const char *s)
{
while( (*d++ = *s++) ) ;
}

bool isWritable(int uid, int gid, struct stat64 *st)
{
if(uid==0)return true;
if(uid==st->st_uid)
    return (st->st_mode&S_IWUSR); 
if(gid==st->st_gid)
    return (st->st_mode&S_IWGRP); 
return (st->st_mode&S_IWOTH);
}

bool isReadable(int uid, int gid, struct stat64 *st)
{
if(uid==0)return true;
if(uid==st->st_uid)
    return (st->st_mode&S_IRUSR); 
if(gid==st->st_gid)
    return (st->st_mode&S_IRGRP); 
return (st->st_mode&S_IROTH);
}

bool isExecable( int uid, int gid, struct stat64 *st )
{
int  m=st->st_mode;
if( uid==0&&S_ISDIR(m) )return true;
if(uid==st->st_uid)return (m&S_IXUSR); 
if(gid==st->st_gid)return (m&S_IXGRP); 
return (m&S_IXOTH);
}

bool rightFileName(char *pth, const char **flt)
{
char *dnam;
struct stat64 st;
int rt=stat64(pth, &st);
*flt=NULL;
if( rt || S_ISDIR(st.st_mode)==false ){
  if( (dnam=strrchr(pth, ROOT_CH))!=NULL ){
	if(dnam!=pth){
		*dnam++=0;
		*flt=strdup(dnam);
		}
	else {
		*flt=strdup(++dnam);
		*dnam=0;
	}
	if(rt && stat64(pth, &st) )return false;
	}
  }
return true;
}

/*int namcmp(const char *nam1, const char *nam2, bool cs) // no ext
{
int n=0;
if(*nam1=='.'){
	if(*nam2!='.')return -1;
	n=1;
	}
else if(*nam2=='.')return 1;

int rt, ch1, ch2, i, tmp=-0x7fff, isNumCmp=0;
const unsigned char *pt1=(unsigned char *)nam1,
	*pt2=(unsigned char *)nam2;
i=n;
loop:	ch1=pt1[i];	ch2=pt2[i];
	if(isNumCmp==2&&(is_numb(ch1)==false||is_numb(ch2)==false)){
		if(is_numb(ch2))return -1; // like 2mt,10mt cmp
		if(is_numb(ch1))return 1; // like 2mt 10mt cmp
		return tmp;
		}
	if(cs==false){
		if(ch1>'A'-1 && ch1< 'Z'+1)ch1|=32;
		if(ch2>'A'-1 && ch2< 'Z'+1)ch2|=32;
		}
	rt= ch1 - ch2 ;
	if( rt  || ch1==0||ch2==0 ){
	    if((ch1=='+'||ch1=='-') && (ch2=='+'||ch2=='-') )rt=-rt; // '+' less '-' in ASCII
	    if( is_numb(ch1) && is_numb(ch2) ){
		isNumCmp=2;
		if(tmp==-0x7fff)tmp=rt;
		}
	    else {
		if(isNumCmp==false){
			if(rt==0&&cs==false){ _re_start_: i=n;  cs=true; goto loop; }
			else return rt;
			}
		if(is_numb(ch2))return -1; // 16x16; 32x32; 128x128 cmp
		if(is_numb(ch1))return 1; // 16x16; 32x32; 128x128 cmp
		if(rt==0&&cs==false)goto _re_start_;
		else return rt;
		}
	}
	else isNumCmp=is_numb(ch1) ? (isNumCmp==2 ? 2:1) : 0;
	i++;
	goto loop;
}*/

#define is_numb(ch) (ch>47 && ch<58)
#define  orgcmp  -0x7fff
int namcmp(const char *nam1, const char *nam2, bool cs)
{
int n;
const char *ext1=strrchr(nam1, '.'),
	*ext2=strrchr(nam2, '.');
if(*nam1=='.'){
	if(*nam2!='.')return -1;
	if(nam1==ext1)ext1=NULL;
	if(nam2==ext2)ext2=NULL;
	n=1;
}
else {
	if(*nam2=='.')return 1;
	n=0;
	}
int rt,  i, tmp=orgcmp, isNumCmp=0;
const unsigned char *pt1=(unsigned char *)nam1,
	*pt2=(unsigned char *)nam2;

if(ext1){ // as prog-1.1.2 > prog-1.6, so ...
	register const char *pt=ext1;
	while(  is_numb(*pt) )pt++;
	if(*pt)ext1=NULL;
	}
if(ext2){ // as prog-1.1.2 > prog-1.6, so ...
	register const char *pt=ext2;
	while(  is_numb(*pt) )pt++;
	if(*pt)ext2=NULL;
	}
register int ch1, ch2;

_loop_:	i=n;
loop:	ch1=pt1[i];	ch2=pt2[i];
	if(isNumCmp==2&&(is_numb(ch1)==false||is_numb(ch2)==false)){
		if(is_numb(ch2))return -1; // like 2mt, 10mt cmp
		if(is_numb(ch1))return 1;
		return tmp;
		}
	if(cs==false){
		if(ch1>'A'-1 && ch1< 'Z'+1)ch1|=32;
		if(ch2>'A'-1 && ch2< 'Z'+1)ch2|=32;
		}
	rt= ch1 - ch2 ;
	if( rt  || ch1==0||ch2==0 ){
	    if((ch1=='+'||ch1=='-') && (ch2=='+'||ch2=='-') )rt=-rt; // '+' less '-' in ASCII
	    if( (ext1 && ext1<=(char *)(pt1+i) ) &&
		(ch2&&(ext2==NULL||ext2>(char *)(pt2+i))) )return -1;
	    if( (ext2 && ext2<=(char *)(pt2+i)) &&
		(ch1&&(ext1==NULL||ext1>(char *)(pt1+i)) ) ) return 1;

	    if( is_numb(ch1) && is_numb(ch2) ){
		isNumCmp=2;
		if(tmp==orgcmp)tmp=rt;
		}
	    else {
		if(isNumCmp==0 ){
	_re_start_:	if(rt==0&&cs==false){ cs=true; goto _loop_; }
			else return rt;
			}
		if(is_numb(ch2))return -1; // 16x16; 32x32; 128x128 cmp
		if(is_numb(ch1))return 1; // 16x16; 32x32; 128x128 cmp
		// int ret = ( ( pt1+i==(const unsigned char *) ext1)|| (ch1|32)==32  && ch2) ||( ( pt2+i==(const unsigned char *)ext2 )|| (ch2|32)==32 && ch1)  ? rt : tmp;
		goto _re_start_; // 丄17定要
		}
	}
	else isNumCmp=is_numb(ch1) ? (isNumCmp==2 ? 2:1) : 0;
	i++;
	goto loop;
}

FastBlock *getLogors(const char *fileNam, int **IDs)
{
FastBlock *useNam,	use(NoFree);
char *buf, **lst;
int i, *useId, cnt;
unsigned int len;
buf=ReadFile(fileNam, &len, true /* txtmode */, NULL, &pathList);
if(buf==NULL)return NULL;

FastBlock chs(buf, "\n");
chs.sort(false,true);
cnt=chs.count();
lst=chs.plist();

useId=(int *)malloc(sizeof(int) * cnt);
*IDs=useId;
useNam=new FastBlock;
for(i=0; i< cnt; i++){
	use.resetMem(lst[i], ":");
	if(use.count() > 2){
		useNam->add(use.lstIndex(0));
		*useId++=atoi(use.lstIndex(2));
	}
}
return useNam;
}

static const  char SPC[]="";
fsp_dir *_diropen(fsp_dir *pdir, const char *dirnam)
{
fsp_dir *dir=pd_open(pdir, dirnam, DIR_READ);
if(idxdscpt<0x7ffd){
	char buf[300], *pth;
	sprintf(buf, "FSP-dir : fail to open \"%s/%s\"" , pdir? (pth=pdPathNam(pdir, NULL, 0)) : SPC, dirnam);
	if(pdir)free(pth);
	ManuTxt(idxdscpt, buf);
}
return dir;
}

int numbRead(fsp_dir *dir, int numb, MAU *send, int n, bool msg)
{
/* BYTE *stat=num_read(lib,dir,numb,send,n);
if(_idxdscpt<0x7ffd && msg )pWarning(num_fmts , _idxdscpt, dir? dir->name : SPC, numb);
return stat;*/
BYTE *fcu=num_read(dir,numb,send,n);
if(fcu){
BYTE m=fcu[1];
free(fcu);
return m;
}
if(msg){
char buf[320], *pth;
sprintf(buf, "FSP-Id : fail to read \"%s/%d\"", dir? (pth=pdPathNam(dir, NULL, 0)) : SPC, numb);
if(dir)free(pth);
ManuTxt(idxdscpt, buf);
}
return -1;
}

bool numbWrite(fsp_dir *dir, int numb, MAU *send, int n)
{
if(num_write(dir,numb,send,n))return true;
char buf[320], *pth;
sprintf(buf, "FSP-Id : fail to write \"%s/%d\"", dir? (pth=pdPathNam(dir, NULL, 0)) : SPC, numb);
if(dir)free(pth);
ManuTxt(idxdscpt, buf);
return false;
}

#include "listopera.cpp"
