/*
    Write by LinJiangHua(xempo) 8-2011
    Copyright LinJiangHua 8-2011
*/

#include <qcursor.h>
#include "filesan.h"
#include "treeview.h"
#include "xfunc.h"
#include "../rtdata/en/target/filesor.h"

int icoTimId;

extern bool canDrop(QMimeSource *e, const char *dst); // listcontect.h

#define	restoreOn	128

const char vIcon[]="vIco";

IVItem::IVItem(QIconView *v, IVItem *after, const char *txt, bool isdir, bool can_drop) :
	QIconViewItem(v, after, tranText(strCodec, txt)),
	fnam(strdup(txt)), _dir(isdir), _canDrop(isdir&&can_drop)
{
}

IVItem::IVItem(QIconView *v, IVItem *after, const char *txt, const QPixmap &icon, QTextCodec *codec, bool isdir, bool can_drop) :
	QIconViewItem(v, after, tranText(codec, txt), icon),
	fnam(strdup(txt)), _dir(isdir), _canDrop(isdir&&can_drop)
{
}

IVItem::~IVItem()
{
free(fnam);
}

void IVItem::_setName(const char *nam)
{
free(fnam);
fnam=strdup(nam);
}

ImageFileView::ImageFileView(QWidget *par) : QIconView(par, vIcon),
	selItem(NULL), tms(0), filesor((Filesan *)(par->parentWidget()->parentWidget()->parentWidget())),
	testResult(0), dragIcon(NULL),
	dragOpen(*pixmapLoad(dragOpenImg))
{
setResizeMode(QIconView::Adjust);
setGridX(80);
setSorting(false);
setWordWrapIconText( true );
setSelectionMode(QIconView::Extended);
//connect(this, SIGNAL(dropped(QDropEvent *, const QValueList<QIconDragItem> &)),
//	filesor, SLOT(dropExec()) ); move to Filesan::creatIconView
}

IVItem *ImageFileView::Index(int idx)
{
int i;
IVItem *ico=(IVItem *)firstItem();
for(i=0; i<idx; i++)ico=(IVItem *)ico->nextItem();
return ico;
}

QStrList FastBlock::cvtQStrList()
{
  QStrList lst(false); //only ptrs collect
  int i;
  if(list==NULL)memDiv(NULL);
  for(i=0; i<cnt; i++)lst.append(list[i]); // shadow copy, only char * copy
  return lst;
}

bool ImageFileView::event( QEvent *e )
{
switch(e->type()){
case QEvent::Timer : if(++tms>6){
	IVItem *ico = (IVItem *)findItem( viewport()->mapFromGlobal( QCursor::pos() ) );
	tms=0;
	if( ico !=selItem )setSelStat(ico);
	}
	return true;

case QEvent::FocusIn : filesor->objsUpdate();
}
return QIconView::event(e);
}

int ImageFileView::testFile(IVItem * ico, char *pt)
{
  IVItem *curIco=(IVItem *)currentItem();
  struct stat64 sndstat;
  int rt;
  switch(rt=isExist(pt, &sndstat)){
//  case none_File :	// ico=(IVItem *)ico->nextItem(); if(ico)return 1;
//		return -1;
  case lost_Link :  if(curIco==ico)showLink(filesor->stBar(), lnkNone, pt, 0xe03b0a);
	break;
  case symLink : if(curIco==ico)showLink(filesor->stBar(), linkAs, pt, 0x208020);
	}
  return rt;
}

void ImageFileView::selectedCollect(FastBlock *fsels)
{
IVItem *curIco=(IVItem *)currentItem();
if(curIco){
  char *pt;
  int idx;
  IVItem   *ico=(IVItem *)firstItem();
  fsels->setIndex(0);
  do if( ico->isSelected() /*&& ico->fnam */){
	pt=filesor->itemFullPath( ico );
	switch(testFile(ico, pt)){
	case lost_Link :
	case 0 :
	case symLink : idx=fsels->add( pt );
		if(curIco==ico)fsels->setIndex(idx);
	}
	free(pt);
	}
  while( /*ico &&*/ (ico=(IVItem *)ico->nextItem())!=NULL );
  fsels->memDiv(NULL);
}
}

IVItem *ImageFileView::curSelIco()
{
IVItem *curIco=(IVItem *)currentItem(), *selIco=NULL;
if(curIco){
  IVItem  *ico=(IVItem *)firstItem();
  do if( ico->isSelected()  ){
	if(ico==curIco)return ico;
	selIco=ico;
	}
  while( /*ico &&*/ (ico=(IVItem *)ico->nextItem())!=NULL );
}
return selIco ? selIco : curIco;
}

QDragObject *ImageFileView::dragObject()
{
 IVItem *ico=(IVItem *)currentItem();
 if(ico){
  QUriDrag *ud = new QUriDrag( filesor->getFSels()->cvtQStrList(), viewport());
  ud->setPixmap(*ico->pixmap());
  dragIcon=ico;
  ud->drag();
  endTimer();
  dragIcon=NULL;
 }
 return NULL;
}

void ImageFileView::restoreIcon()
{
tms=0;
if(testResult==restoreOn)selItem->setPixmap(oldpix);
//if(set)
selItem=NULL;
testResult=0;
}

void ImageFileView::setSelStat(IVItem *ico)
{
if(ico->getCanDrop()){
    tms=0;
    char *fnam=filesor->itemFullPath( ico );
    int H=strcmp(fnam, home);
    testResult=testFile(ico, fnam);
    free(fnam);
    switch(testResult){
// case lost_Link : break;
    case 0 :
    case symLink :
	if(dragIcon!=ico){
		selItem=ico;
		oldpix=*ico->pixmap();
		ico->setPixmap(H==0 ? *pixmapLoad( _homeOpenImg) : dragOpen );
		testResult=restoreOn;
	}
    }
}
}

void ImageFileView::endTimer()
{
if(icoTimId){
	killTimer(icoTimId);
	icoTimId=0;
	}
}

void IVItem::dragLeft()
{
((ImageFileView *)iconView())->endTimer();
((ImageFileView *)iconView())->restoreIcon();
}

void IVItem::dragEntered()
{
((ImageFileView *)iconView())->setTms(0);
if(icoTimId==0)	icoTimId=iconView()->startTimer(80);
//else ((ImageFileView *)iconView())->setSelStat(this);
}

bool IVItem::acceptDrop( const QMimeSource *e ) const
{
return _canDrop;
}

void IVItem::dropped( QDropEvent *e, const QValueList<QIconDragItem> & )
{
IVItem *icon=((ImageFileView *)iconView())->getSelItem();
if(icon){
  ImageFileView *_iconview=(ImageFileView *)iconView();
  _iconview->endTimer();
  Filesan *fs=_iconview->_filesor();
  char *dst=fs->itemFullPath( icon );
  if(canDrop(e,dst))procDrop(fs, fs, e, dst);
  else fs->stBar()->showMsg(DropSub, 30, true, 0x9a2420);
  _iconview->restoreIcon();
  free(dst);
}
else e->ignore();
}

